//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.tiptimes.service.impl;

import com.tiptimes.dao.SpaceFundDao;
import com.tiptimes.dao.SpaceFundUseDao;
import com.tiptimes.dao.SpaceMessageDao;
import com.tiptimes.model.SpaceFund;
import com.tiptimes.model.SpaceFundUse;
import com.tiptimes.model.SpaceMessage;
import com.tiptimes.service.SpaceFundService;
import java.text.NumberFormat;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class SpaceFundServiceImpl implements SpaceFundService {
    @Autowired
    private SpaceFundDao spaceFundDao;
    @Autowired
    private SpaceFundUseDao spaceFundUseDao;
    @Autowired
    private SpaceMessageDao spaceMessageDao;

    public SpaceFundServiceImpl() {
    }

    @Transactional
    public void saveSpaceFund(SpaceFund spaceFund) {
        this.spaceFundDao.saveSpaceFund(spaceFund);
    }

    @Transactional
    public void updateSpaceFund(SpaceFund spaceFund) {
        this.spaceFundDao.updateSpaceFund(spaceFund);
    }

    public SpaceFund listSpaceFundBySpaceMessageID(String spaceMessageID) {
        List<SpaceFund> spaceFund_list = this.spaceFundDao.listSpaceFundBySpaceMessageID(spaceMessageID);
        return spaceFund_list.size() == 0 ? null : (SpaceFund)spaceFund_list.get(0);
    }

    public Map<String, Object> listSpaceFundAndMessageBySpaceMessageID(String spaceMessageID) {
        List<Map<String, Object>> spaceFund_list = this.spaceFundDao.listSpaceFundAndMessageBySpaceMessageID(spaceMessageID);
        return spaceFund_list.size() == 0 ? null : (Map)spaceFund_list.get(0);
    }

    @Transactional(
            rollbackFor = {Exception.class}
    )
    public void saveSpaceFundUse(SpaceFundUse spaceFundUse, String spaceMessageID) {
        this.spaceFundUseDao.saveSpaceFundUse(spaceFundUse);
        double spaceFundMoneyNum = 0.0D;
        List<SpaceFundUse> spaceFundUse_list = this.spaceFundUseDao.listSpaceFundUseBySpaceFundID(spaceFundUse.getSpaceFundID());
        SpaceFundUse spaceFundUse_list_i;
        if (spaceFundUse_list.size() != 0) {
            for(Iterator var6 = spaceFundUse_list.iterator(); var6.hasNext(); spaceFundMoneyNum += Double.parseDouble(spaceFundUse_list_i.getSpaceFundUseMoney())) {
                spaceFundUse_list_i = (SpaceFundUse)var6.next();
            }
        }

        List<SpaceMessage> SpaceMessage_list = this.spaceMessageDao.getSpaceMessageBySpaceMessageID(spaceMessageID);
        if (SpaceMessage_list.size() > 0) {
            SpaceMessage spaceMessage = (SpaceMessage)SpaceMessage_list.get(0);
            spaceMessage.setSpaceFundMoneyNum(spaceFundMoneyNum + "");
            spaceMessage.setSpaceFundNumber(spaceFundUse_list.size());
            this.spaceMessageDao.updateSpaceMessage(spaceMessage);
        }

    }

    @Transactional(
            rollbackFor = {Exception.class}
    )
    public void updateSpaceFundUse(SpaceFundUse spaceFundUse, String spaceMessageID) {
        this.spaceFundUseDao.updateSpaceFundUse(spaceFundUse);
        double spaceFundMoneyNum = 0.0D;
        List<SpaceFundUse> spaceFundUse_list = this.spaceFundUseDao.listSpaceFundUseBySpaceFundID(spaceFundUse.getSpaceFundID());
        SpaceFundUse spaceFundUse_list_i;
        if (spaceFundUse_list.size() != 0) {
            for(Iterator var6 = spaceFundUse_list.iterator(); var6.hasNext(); spaceFundMoneyNum += Double.parseDouble(spaceFundUse_list_i.getSpaceFundUseMoney())) {
                spaceFundUse_list_i = (SpaceFundUse)var6.next();
            }
        }

        List<SpaceMessage> SpaceMessage_list = this.spaceMessageDao.getSpaceMessageBySpaceMessageID(spaceMessageID);
        if (SpaceMessage_list.size() > 0) {
            SpaceMessage spaceMessage = (SpaceMessage)SpaceMessage_list.get(0);
            spaceMessage.setSpaceFundMoneyNum(spaceFundMoneyNum + "");
            spaceMessage.setSpaceFundNumber(spaceFundUse_list.size());
            this.spaceMessageDao.updateSpaceMessage(spaceMessage);
        }

    }

    @Transactional(
            rollbackFor = {Exception.class}
    )
    public void removeSpaceFundUse(String spaceFundUseID, String spaceMessageID) {
        List<SpaceFundUse> spaceFundUse_list = this.spaceFundUseDao.listSpaceFundUseBySpaceFundUseID(spaceFundUseID);
        if (spaceFundUse_list.size() != 0) {
            this.spaceFundUseDao.removeSpaceFundUse(spaceFundUseID);
            double spaceFundMoneyNum = 0.0D;
            List<SpaceFundUse> spaceFundUse_list1 = this.spaceFundUseDao.listSpaceFundUseBySpaceFundID(((SpaceFundUse)spaceFundUse_list.get(0)).getSpaceFundID());
            SpaceFundUse spaceFundUse_list_i;
            if (spaceFundUse_list1.size() != 0) {
                for(Iterator var7 = spaceFundUse_list1.iterator(); var7.hasNext(); spaceFundMoneyNum += Double.parseDouble(spaceFundUse_list_i.getSpaceFundUseMoney())) {
                    spaceFundUse_list_i = (SpaceFundUse)var7.next();
                }
            }

            List<SpaceMessage> SpaceMessage_list = this.spaceMessageDao.getSpaceMessageBySpaceMessageID(spaceMessageID);
            if (SpaceMessage_list.size() > 0) {
                SpaceMessage spaceMessage = (SpaceMessage)SpaceMessage_list.get(0);
                NumberFormat nf = NumberFormat.getInstance();
                spaceMessage.setSpaceFundMoneyNum(nf.format(spaceFundMoneyNum));
                spaceMessage.setSpaceFundNumber(spaceFundUse_list1.size());
                this.spaceMessageDao.updateSpaceMessage(spaceMessage);
            }

        }
    }

    public List<SpaceFundUse> listSpaceFundUseBySpaceFundID(String spaceFundID) {
        List<SpaceFundUse> spaceFundUse_list = this.spaceFundUseDao.listSpaceFundUseBySpaceFundID(spaceFundID);
        return spaceFundUse_list.size() == 0 ? null : spaceFundUse_list;
    }

    public List<SpaceFundUse> listSpaceFundUseBySpaceFundIDAndOthers(String spaceFundID, SpaceFundUse spaceFundUse) {
        List<SpaceFundUse> spaceFundUse_list = this.spaceFundUseDao.listSpaceFundUseBySpaceFundIDAndOthers(spaceFundID, spaceFundUse);
        return spaceFundUse_list.size() == 0 ? null : spaceFundUse_list;
    }

    public SpaceFundUse getSpaceFundUseBySpaceFundUseID(String spaceFundUseID) {
        List<SpaceFundUse> spaceFundUse_list = this.spaceFundUseDao.listSpaceFundUseBySpaceFundUseID(spaceFundUseID);
        return spaceFundUse_list.size() == 0 ? null : (SpaceFundUse)spaceFundUse_list.get(0);
    }

    public String getSpaceFundUseNumByCertification(int certification) {
        return this.spaceFundUseDao.getSpaceFundUseNumByCertification(certification);
    }
}
